<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: infusion.php for World_Clock_Panel
| Author: Stewart Wilkinson G0LGS
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }

include INFUSIONS."world_clock_panel/infusion_db.php";

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."world_clock_panel/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."world_clock_panel/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."world_clock_panel/locale/English.php";
}

// General information
$inf_title = $locale['wrc_title'];
$inf_description = $locale['wrc_desc'];
$inf_version = "0.9";
$inf_developer = "Stewart G0LGS";
$inf_email = "phpmods@g0lgs.co.uk";
$inf_weburl = "http://www.g0lgs.co.uk/";

// The folder in which the infusion resides.
$inf_folder = "world_clock_panel"; 

// Create Table
$inf_newtable[1] = DB_WORLDCLOCK." (
  wcid SMALLINT(2) UNSIGNED AUTO_INCREMENT,
  wcname VARCHAR(40) DEFAULT '',
  wczone SMALLINT(2) DEFAULT '0',
  wcdst SMALLINT(2) UNSIGNED DEFAULT '0',
  PRIMARY KEY  (wcid)
) Type=MyISAM;";

/*
wcdst	Area
1	EU/UK
2	USA
3	AUS
4	NZ
*/

// Populate Table
$inf_insertdbrow[1] = DB_WORLDCLOCK." (wcid, wcname, wczone, wcdst) VALUES 
	(1, 'GMT/UTC', 0, 0),
	(2, 'Moscow', 3, 1),
	(3, 'Hawaii', -10, 0),
	(4, 'London', 0, 1),
	(5, 'Tokyo', 9, 0),
	(6, 'New York', -5, 2),
	(7, 'Wellington', 12, 4),
	(8, 'Sydney', 10, 3),
	(9, 'Perth', 8, 3),
	(10, 'Cyprus', 2, 1),
	(11, 'Athens', 2, 1),
	(12, 'Amsterdam', 1, 1),
	(13, 'Kuwait City', 3, 0),
	(14, 'Ottawa', -5, 2),
	(15, 'Seattle', -8, 2),
	(16, 'Istanbul', 2, 1)";

// Drop Table
$inf_droptable[1] = DB_WORLDCLOCK;

/*
// The Administrators Panel
$inf_adminpanel[1] = array(
	"title" => $locale['wrc_admin1'],
	"image" => "image.gif",
	"panel" => "world_clock_panel_admin.php",
	"rights" => "XXX"
);
/*

/*
// Navigation Panel Link
// NOT Required
$inf_sitelink[1] = array(
	"title" => $locale['xxx_link1'],
	"url" => "filename.php",
	"visibility" => "0"
);
*/

?>
