<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: world_clock_panel.php
| Author: Stewart Wilkinson G0LGS
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }

include INFUSIONS."world_clock_panel/infusion_db.php";

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."world_clock_panel/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."world_clock_panel/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."world_clock_panel/locale/English.php";
}

// Various options that control the appearance
$use24 = TRUE;		// use 24 Hour Clock
$showsecs = FALSE;	// Display Seconds
$showday = TRUE;	// Show Day of Week
$dayl = FALSE;		// Long Day Names
$shzone = FALSE;	// Show Zones
$shlocal = TRUE;	// Show Local Time

// Marquee Options (Odd things happen in FireFox with some settings).
// Will fail W3C Validation too
$usemarquee = FALSE;	// Use Marquee ?
$mwidth = "100%";	// Set > 100% to make it wider than normal left / right panel.
$scrolldirection = "up";

// Show where DST is Active (*)
$ShowDSTActive=TRUE;

// Order to Display (Pick one)
$Order = "ORDER BY wcname ASC";
//$Order = "ORDER BY wcid ASC";
//$Order = "ORDER BY wczone ASC";

openside($locale['wrc_title']);

$result = dbquery("SELECT * FROM ".DB_WORLDCLOCK." ".$Order );

// Null Return
if(!$result) { echo "<p>Error: Unable to Display</p>" ; closeside(); return; }

// Create HTML Table for Results

$content = "";
$content .= "<!-- Start of World Clock -->\n";

$l=0;
$content .= "<table width='100%' cellpadding='1' cellspacing='0' border='0'>\n";

if ($usemarquee) {
	$content .= "<tr><td>\n";
        $content .= "<marquee behavior='scroll' direction='$scrolldirection' height='80' scrollamount='2' scrolldelay='100' onmouseover='this.stop()' onmouseout='this.start()'>";
	$content .= "<table width='$mwidth' cellpadding='1' cellspacing='0' border='0'>\n";
}

while( $data = dbarray($result) ){
	$wcname = stripslashes(htmlspecialchars($data['wcname']));
	$wczone = $data['wczone'];
	$wcdst = $data['wcdst'];

	$tz[$l] = "tzone($wczone, $wcdst)";

	$wcname = str_replace("_", " ", $wcname);

	$content .= "<tr><td align='left'>";
	$content .= "<a title='".$wcname." (". (($wczone>=0)? "+" : "") .($wczone). ")' >". $wcname . "</a></td>\n";
	if( $shzone ){
		$content .= "<td align='center'>(". (($wczone>=0)? "+" : "") .($wczone). ")</td>\n";
	}
	$content .= "<td id='wrc_clock".$l."' align='right'>&nbsp;</td></tr>\n";
	$l++;
}

$content .= "</table>\n";


if ($usemarquee) {
        $content .= "</marquee>\n";
	$content .= "</td></tr>\n";
	$content .= "</table>\n";
}

if( $shlocal ){
	$content .= "<table width='100%' cellpadding='1' cellspacing='0' border='0'>\n";
	$content .= "<tr><td width='100%' align='center'><hr size='1' noshade='noshade' /></td></tr>\n";
	$content .= "</table>\n";

	$content .= "<table width='100%' cellpadding='1' cellspacing='0' border='0'>\n";
	$content .= "<tr><td align='left'>".$locale['wrc_local']."</td>\n";
	$content .= "<td id='wrc_local' align='right'>&nbsp;</td></tr>\n";
	$content .= "</table>\n";
}

$content .= "<table width='100%' cellpadding='1' cellspacing='0' border='0'>\n";
$content .= "<tr><td width='100%' align='center'><hr size='1' noshade='noshade' /></td></tr>\n";
$content .= "<tr><td width='100%' align='center'>".$locale['wrc_title']."<br />Infusion by G0LGS</td></tr>\n";
$content .= "</table>\n";

// Create JavaScript with Choosen Options

$content .= "<!-- Start of Java for World Clock -->\n";
$content .= "<script type='text/javascript' language='JavaScript'>\n";
$content .= "//<![CDATA[\n";

$content .= "var timerID;\n";

$content .= "if(document.all && !document.getElementById) {\n";
$content .= "	document.getElementById = function(id) {\n";
$content .= "		return document.all[id];\n";
$content .= "	}\n";
$content .= "}\n";

$content .= "function tzone(os, ds)\n";
$content .= "{\n";
$content .= "	this.ct = new Date(0);	// datetime\n";
$content .= "	this.os = os ;		// GMT offset\n";
$content .= "	this.ds = ds ;		// DS Zone\n";
$content .= "	this.da = 0 ;		// DS Active\n";
$content .= "}\n";

$content .= "function ShowClocks()\n";
$content .= "{\n";
$content .= "	var ct = new Array(\n";
$content .= "		new $tz[0]";

$l1=1;
while($l1 < $l ){
	$content .= ",\n		new $tz[$l1]";
	$l1++;
}
$content .= "\n	) ;\n";

$content .= "	var element;\n";

$content .= "	var dt = new Date() ;	// [GMT] time according to machine clock\n";
if( !$showsecs ){
	$content .= " 	var secs = dt.getUTCSeconds();\n";
}

$content .= "\n	// Adjust clock offset if required.\n";
$content .= "	n=0;\n";
$content .= "	while( n < ct.length ){\n";

$content .= "		if ( ct[n].ds == 0 ){\n";
$content .= "			n++;\n";
$content .= "			continue;\n";
$content .= "		};\n";

$content .= "		var Month = dt.getUTCMonth();\n";

$content .= "		if(ct[n].ds == 1){ // EU DST Rules\n";
$content .= "			var startDST = new Date(dt.getFullYear(), 2, 31, 1, 0, 0, 0);// 01:00 Last Sunday in March\n";
$content .= "			while (startDST.getDay() != 0)\n";
$content .= "				startDST.setDate(startDST.getDate() -1);\n";
$content .= "			var endDST = new Date(dt.getFullYear(), 9, 31, 1, 0, 0, 0);// 01:00(GMT) Last Sunday in October\n";
$content .= "			while (endDST.getDay() != 0)\n";
$content .= "				endDST.setDate(endDST.getDate() - 1);\n";
$content .= "		}\n";

$content .= "		if(ct[n].ds == 2){ // USA DST Rules\n";
$content .= "			var startDST = new Date(dt.getFullYear(), 3, 1, 2, 0, 0, 0);// 02:00\n";
$content .= "			while (startDST.getDay() != 0)\n";
$content .= "				startDST.setDate(startDST.getDate() +1);\n";

$content .= "			var endDST = new Date(dt.getFullYear(), 9, 31, 2, 0, 0, 0);// 02:00\n";
$content .= "			while (endDST.getDay() != 0)\n";
$content .= "				endDST.setDate(endDST.getDate() - 1);\n";
$content .= "		}\n";

$content .= "		if(ct[n].ds == 3){ // AUS DST Rules\n";
$content .= "			if (Month>=9) {\n";
$content .= "				Ofs1=0;\n";
$content .= "				Ofs2=1;\n";
$content .= "			}else{\n";
$content .= "				Ofs1=-1;\n";
$content .= "				Ofs2=0;\n";
$content .= "			}\n";

$content .= "			var startDST = new Date(dt.getFullYear()+Ofs1, 9, 31, 2, 0, 0, 0);\n";
$content .= "			while (startDST.getDay() != 0)\n";
$content .= "				startDST.setDate(startDST.getDate() -1);\n";

$content .= "			var endDST = new Date(dt.getFullYear()+Ofs2, 3, 1, 3, 0, 0, 0);\n";
$content .= "			while (endDST.getDay() != 0)\n";
$content .= "				endDST.setDate(endDST.getDate() - 1);\n";
$content .= "		}\n";

$content .= "		if(ct[n].ds == 4){ // NZ DST Rules\n";
$content .= "			if (Month>=9) {\n";
$content .= "				Ofs1=0;\n";
$content .= "				Ofs2=1;\n";
$content .= "			}else{\n";
$content .= "				Ofs1=-1;\n";
$content .= "				Ofs2=0;\n";
$content .= "			}\n";

$content .= "			var startDST = new Date(dt.getFullYear()+Ofs1, 9, 1, 2, 0, 0, 0);\n";
$content .= "			while (startDST.getDay() != 0)\n";
$content .= "				startDST.setDate(startDST.getDate() +1);\n";

$content .= "			var endDST = new Date(dt.getFullYear()+Ofs2, 3, 1, 3, 0, 0, 0);\n";
$content .= "			while (endDST.getDay() != 0)\n";
$content .= "				endDST.setDate(endDST.getDate() - 1);\n";
$content .= "			endDST.setDate(endDST.getDate() - 7);\n";
$content .= "		}\n";

$content .= "		// Check if DST is Active\n";
$content .= "		if (startDST < dt && dt < endDST)\n";
$content .= "			ct[n].da = 1 ;\n";
$content .= "		else\n";
$content .= "			ct[n].da = 0 ;\n\n";

$content .= "		if (ct[n].da == 1) ct[n].os++;\n\n";

$content .= "		n++;\n";
$content .= "	}\n";

$content .= "\n	// compensate time zones\n";
$content .= "	gmdt = new Date();\n";
$content .= "	for (n=0 ; n < ct.length ; n++)\n";
$content .= "		ct[n].ct = new Date(gmdt.getTime() + ct[n].os * 3600 * 1000);\n\n";

$l1=0;
while($l1 < $l ){
	// There ought to be a better JavaScript way of doing this.

	if( ! $ShowDSTActive ){
		$content .= "	document.getElementById('wrc_clock" .($l1). "').innerHTML = ClockString(ct[" .($l1). "].ct);\n";
	}else{
		$content .= "	document.getElementById('wrc_clock" .($l1). "').innerHTML = ((ct[".($l1)."].da)? \"* \" : \"\") + ClockString(ct[" .($l1). "].ct);\n";
	}

	$l1++;
}

if( $shlocal ){
	$content .= "	document.getElementById('wrc_local').innerHTML = LocalClockString(new Date());\n";
}

// Select Update Timing
if( $showsecs ){
	$content .= "\n 	timerID = window.setTimeout('ShowClocks()', 500) ;\n";
}else{
	$content .= "\n 	timerID = window.setTimeout('ShowClocks()', ((60-secs)*1000)+10) ;\n";
}

$content .= "}\n";

$content .= " function ClockString(dt)\n";
$content .= " {\n";
$content .= " 	var dtmp, ampm ;\n";
$content .= " 	var hour = dt.getUTCHours();\n";
$content .= " 	var mins = dt.getUTCMinutes();\n";
$content .= " 	var secs = dt.getUTCSeconds();\n";
if( $showday ){
	$content .= "	var dow = dt.getUTCDay();\n";
	if( $dayl ){
		$content .= "	var days = new Array(\n";
		$content .= "		'Sunday',\n";
		$content .= "		'Monday',\n";
		$content .= "		'Tuesday',\n";
		$content .= "		'Wednesday',\n";
		$content .= "		'Thursday',\n";
		$content .= "		'Friday',\n";
		$content .= "		'Saturday'\n";
		$content .= "	);\n";
	}else{
		$content .= "	var days = new Array(\n";
		$content .= "		'Sun',\n";
		$content .= "		'Mon',\n";
		$content .= "		'Tue',\n";
		$content .= "		'Wed',\n";
		$content .= "		'Thu',\n";
		$content .= "		'Fri',\n";
		$content .= "		'Sat'\n";
		$content .= "	);\n";
	}
}

if( $use24 ){
	$content .= " 	if ( hour < 10 )\n";
	$content .= " 		hour = '0' + hour;\n";
}else{
	$content .= " 	if (0 <= hour && hour < 12)\n";
	$content .= " 	{\n";
	$content .= " 		ampm = 'AM' ;\n";
	$content .= " 		if (hour == 0) hour = 12 ;\n";
	$content .= " 	} else {\n";
	$content .= " 		ampm = 'PM' ;\n";
	$content .= " 		hour = hour - 12 ;\n";
	$content .= " 		if (hour == 0) hour = 12 ;\n";
	$content .= " 	}\n";
}

$content .= " 	if (mins < 10)\n";
$content .= " 		mins = '0' + mins ;\n";

if( $showsecs ){
	$content .= " 	if (secs < 10)\n";
	$content .= " 		secs = '0' + secs ;\n";
}

if( $showday ){
	$content .= "	dtmp =	days[dow] + ' ';\n";
}else{
	$content .= "   dtmp =	'';\n";
}

if( $showsecs ){
	$content .= " 	dtmp = dtmp + hour + ':' + mins + ':' + secs;\n";
}else{
	$content .= " 	dtmp = dtmp + hour + ':' + mins;\n";
}

if( !$use24 ){
	$content .= " 	dtmp = dtmp + ' ' + ampm ;\n";
}

$content .= " 	return dtmp ;\n";
$content .= " }\n";

if( $shlocal ){
$content .= " function LocalClockString(dt)\n";
$content .= " {\n";
$content .= " 	var dtmp, ampm ;\n";
$content .= " 	var hour = dt.getHours();\n";
$content .= " 	var mins = dt.getMinutes();\n";
$content .= " 	var secs = dt.getSeconds();\n";
if( $showday ){
	$content .= "	var dow = dt.getDay();\n";
	if( $dayl ){
		$content .= "	var days = new Array(\n";
		$content .= "		'Sunday',\n";
		$content .= "		'Monday',\n";
		$content .= "		'Tuesday',\n";
		$content .= "		'Wednesday',\n";
		$content .= "		'Thursday',\n";
		$content .= "		'Friday',\n";
		$content .= "		'Saturday'\n";
		$content .= "	);\n";
	}else{
		$content .= "	var days = new Array(\n";
		$content .= "		'Sun',\n";
		$content .= "		'Mon',\n";
		$content .= "		'Tue',\n";
		$content .= "		'Wed',\n";
		$content .= "		'Thu',\n";
		$content .= "		'Fri',\n";
		$content .= "		'Sat'\n";
		$content .= "	);\n";
	}
}

if( $use24 ){
	$content .= " 	if ( hour < 10 )\n";
	$content .= " 		hour = '0' + hour;\n";
}else{
	$content .= " 	if (0 <= hour && hour < 12)\n";
	$content .= " 	{\n";
	$content .= " 		ampm = 'AM' ;\n";
	$content .= " 		if (hour == 0) hour = 12 ;\n";
	$content .= " 	} else {\n";
	$content .= " 		ampm = 'PM' ;\n";
	$content .= " 		hour = hour - 12 ;\n";
	$content .= " 		if (hour == 0) hour = 12 ;\n";
	$content .= " 	}\n";
}

$content .= " 	if (mins < 10)\n";
$content .= " 		mins = '0' + mins ;\n";

if( $showsecs ){
	$content .= " 	if (secs < 10)\n";
	$content .= " 		secs = '0' + secs ;\n";
}

if( $showday && !$dayl ){
	$content .= "	dtmp =	days[dow] + ' ';\n";
}else{
	$content .= "   dtmp =	'';\n";
}

if( $showsecs ){
	$content .= " 	dtmp = dtmp + hour + ':' + mins + ':' + secs;\n";
}else{
	$content .= " 	dtmp = dtmp + hour + ':' + mins;\n";
}

if( !$use24 ){
	$content .= " 	dtmp = dtmp + ' ' + ampm ;\n";
}

if( $showday && $dayl ){
	$content .= "	dtmp = dtmp + ' ' + days[dow];\n";
}

$content .= " 	return dtmp ;\n";
$content .= " }\n";
}

$content .= "// Start Clocks\n";
$content .= "ShowClocks()\n";

$content .= "//]]>\n</script>\n";
$content .= "<!-- End of World Clock -->\n";

echo $content;

closeside();

?>
